"""JetRacer ROS 2 setup

This file contains the setup of all relevant packages needed for ROS 2 and the JetRacer.
"""

from setuptools import find_packages, setup
import os
from glob import glob


package_name = 'jetracerros2'

setup(
    name = package_name,
    version = '0.0.0',
    packages = find_packages(exclude = ['test']),
    data_files = [
        ('share/ament_index/resource_index/packages',
         ['resource/' + package_name]),
        ('share/' + package_name, ['package.xml']),
        # Include all launch files.
        (os.path.join('share', package_name, 'launch'), glob(
            os.path.join('launch', '*launch.[pxy][yma]*'))),
    ],
    install_requires = ['setuptools'],
    zip_safe = True,
    maintainer = 'Louis Fink',
    maintainer_email = 'uutyc@student.kit.edu',
    description = 'A ROS 2 package used for controlling the JetRacer ROS AI KIT.',
    license = 'MIT',
    tests_require = ['pytest'],
    entry_points = {
        'console_scripts': [
            'jetracer_controller = jetracerros2.jetracer_controller:main',
            'laser_filter = jetracerros2.laser_filter:main',
            'servo_motor_controller = jetracerros2.servo_motor_controller:main',
        ],
    },
)
