"""Forms

This file provides all forms needed by the webinterface.

This file can be imported as a module and contains the following classes:

    * LoginForm: Form needed to log in a user via a password.
"""

from flask_wtf import FlaskForm
from wtforms import PasswordField, SubmitField
from wtforms.validators import DataRequired


class LoginForm(FlaskForm):
    """
    A form used to log in a user with a given password.
    """

    password = PasswordField("Password", validators = [DataRequired()])
    submit = SubmitField("Log In")
